package com.ppshein.sevendaynews;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.Toast;

public class Index extends Activity {
	
    private static final String JSONURL = "http://www.7daynewsjournal.com/json/featured";
    
	private ImageButton synbut;	
	private Button btnskip;
	private String lastrecordfromlocal, totalCount;
	private ProgressDialog mProgressDialog;
	protected static final int DIALOG_KEY = 0;
	
	DatabaseUtil dbUtil = new DatabaseUtil(this);
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);                      
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.index);
        
        synbut = (ImageButton) findViewById(R.id.imageButton1);
        btnskip = (Button) findViewById(R.id.button1);
        
        try {
	        dbUtil.open();         
	        	Cursor cursor = dbUtil.getTotalRecord();
	        	totalCount = cursor.getString(0);
			dbUtil.close();
        } catch (Exception e1) {
        	totalCount = "0";
        }         
        
        if (Integer.parseInt(totalCount.toString()) > 30) {
        	dbUtil.open();
        		dbUtil.deleteOldData();
        	dbUtil.close();
        }
        
		if (common.isNetAvailable(this) == false) {
    		Toast toast = Toast.makeText(Index.this, "Please turn on mobile or wifi network to get latest news", Toast.LENGTH_SHORT);
    		toast.setGravity(Gravity.CENTER, 0, 0);
    		toast.show();
    		
    		synbut.setEnabled(false);
    		synbut.setAlpha(50);			
		} else {
	        try {
		        dbUtil.open();         
		        	Cursor cursor = dbUtil.getlastRecord();
		        	lastrecordfromlocal = cursor.getString(0);
				dbUtil.close();
	        } catch (Exception e1) {
	        	lastrecordfromlocal = "0";
	        }			
		}
        
		synbut.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View v) {
        		new IsComparedWord().execute(lastrecordfromlocal);   		
        	}
        });
		
		btnskip.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View v) {
        		Intent intent = new Intent();
        		intent.setClass(Index.this, MainActivity.class);
        		startActivity(intent);  		
        	}
        });
	}
	
	private void CheckInstall () {
		showDialog(DIALOG_KEY);
		new InstallData().execute(JSONURL); 		
	}
	
	protected Dialog onCreateDialog(int id) {
        switch (id) {
        case DIALOG_KEY:                                                               // 1
            mProgressDialog = new ProgressDialog(this);
            mProgressDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);         // 2
            mProgressDialog.setMessage("Installation data...");                       // 3
            mProgressDialog.setCancelable(false);                                      // 4
            return mProgressDialog;
        }
        return null;
    }	
	    
    private class IsComparedWord extends AsyncTask<String, Void, String> {
    	private ProgressDialog progressDialog;
                	
        // can use UI thread here
        protected void onPreExecute() {
        	progressDialog = ProgressDialog.show(Index.this, "", "Loading...");
        }
        // automatically done on worker thread (separate from UI thread)
        protected String doInBackground(final String... args) {
        	String resultMessage = null;
        	JSONObject json = common.getJSONfromURL("http://www.planet.com.mm/android/IsCompared.cfm", args[0]);
        	JSONArray newsjson;
			try {				
				newsjson = json.getJSONArray("planetnews");
				for (int i = 0; i < newsjson.length(); i++) {                
					JSONObject e = newsjson.getJSONObject(i);
					resultMessage = e.getString("newwords");                    
	            }        	
				
			} catch (JSONException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
                    	      	                        
        	return resultMessage.toString();
        }
        // can use UI thread here
        protected void onPostExecute(final String result) {
        	progressDialog.dismiss();
        	if (result.equals("0")) {
        		Toast toast = Toast.makeText(Index.this, "There is no updated news yet", Toast.LENGTH_SHORT);
        		toast.setGravity(Gravity.CENTER, 0, 0);
        		toast.show();
        		synbut.setAlpha(50);
        		synbut.setEnabled(false);
        	} else {
        		Toast toast = Toast.makeText(Index.this, "We found updated news. Click below button to update database.", Toast.LENGTH_SHORT);
        		toast.setGravity(Gravity.CENTER, 0, 0);
        		toast.show();
        		synbut.setAlpha(255);
        		synbut.setEnabled(true);
        		CheckInstall();
        	}
        }
     }
    
    protected class InstallData extends AsyncTask<String, Integer, String> {        
        @Override
        protected void onPreExecute() {
        	mProgressDialog.show();
        }
        
        @Override
        protected String doInBackground(String... urls) {
        	try {
	        	JSONObject json = common.getJSONfromURL(urls[0], lastrecordfromlocal);
	        	JSONArray  newsjson = json.getJSONArray("planetnews");
	        	dbUtil.open();
	            for (int i = 0; i < newsjson.length(); i++) {                
	            	JSONObject e = newsjson.getJSONObject(i);
	    			dbUtil.insertRecord(e.getString("newsid"), e.getString("newstitle"), e.getString("newsimage"), e.getString("newslargeimage"), e.getString("newsstory"), e.getString("newscategory"));
	    			publishProgress((int) (((i+1) / (float) newsjson.length()) * 100));
	            }
	            dbUtil.close();
            } catch (JSONException e) {
                e.printStackTrace();                
            }                        
            return "DONE";
        }
        
        @Override
        protected void onProgressUpdate(Integer... values) {
            mProgressDialog.setProgress(values[0]);         
        }
        
        @Override
        protected void onPostExecute(String result) {
        	mProgressDialog.dismiss();
    		Intent intent = new Intent();
    		intent.setClass(Index.this, MainActivity.class);
    		startActivity(intent);  
        }        
    }
    
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
     		AlertDialog.Builder alt_setting = new AlertDialog.Builder(Index.this);
    		alt_setting.setMessage("Do you want to exit?")
    		.setCancelable(false)
    		.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				moveTaskToBack(true);
    			}
    		})
    		.setNegativeButton("No", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				dialog.cancel();
    			}
    		});
    		AlertDialog alert_setting = alt_setting.create();
    		alert_setting.setTitle("Planet Myanmar News");
    		alert_setting.show();
    		return true;
	    }
	    return false;
	}    
}
