package com.ppshein.sevendaynews;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.database.Cursor;
import android.graphics.Typeface;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.text.Html;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.HorizontalScrollView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

import com.ppshein.sevendaynews.MyHorizontalScrollView.SizeCallback;

public class MainActivity extends Activity {
	private MyHorizontalScrollView scrollView;
	private View menu;
	private View app;
	private ImageView btnSlide;
	private TextView categoryTitle;
    boolean menuOut = false;
    Handler handler = new Handler();
    int btnWidth;	
	private ListView listView;
	private String lastrecordfromlocal;
	
    public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_NEWSID = "PrefNewsID";
    public static final String PREF_NEWSCATEGORY = "PrefNewsCategory";
    
    private SharedPreferences mPrefs;    		
    
    private static final String NEWSID = "newsid";
    private static final String NEWSTITLE = "newstitle";
	private static final String NEWSIMAGE = "newsimage";
	private static final String NEWSCATEGORY = "newscategory";
	
	private ArrayList <HashMap<String, Object>> getNews;
	DatabaseUtil dbUtil = new DatabaseUtil(this);

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        LayoutInflater inflater = LayoutInflater.from(this);
        scrollView = (MyHorizontalScrollView) inflater.inflate(R.layout.horz_scroll_with_list_menu, null);
        setContentView(scrollView);

        menu = inflater.inflate(R.layout.horz_scroll_menu, null);
        app = inflater.inflate(R.layout.main, null);
        ViewGroup tabBar = (ViewGroup) app.findViewById(R.id.tabBar_ref);		

        ArrayList<common> image_details = common.GetSearchResults();        

        final ListView lv1 = (ListView) menu.findViewById(R.id.list);
        lv1.setAdapter(new ItemListBaseAdapter(this, image_details));
        
        lv1.setOnItemClickListener(new OnItemClickListener() {
        	@Override
        	public void onItemClick(AdapterView<?> a, View v, int position, long id) { 
        		Object o = lv1.getItemAtPosition(position);
        		common obj_itemDetails = (common)o;
        		Intent myIntent = common.reDirect(obj_itemDetails.getName(), MainActivity.this);
        		startActivity(myIntent);
        	}  
        });        
        
        btnSlide = (ImageView) tabBar.findViewById(R.id.BtnSlide);
        btnSlide.setOnClickListener(new ClickListenerForScrolling(scrollView, menu));
        
        categoryTitle = (TextView) app.findViewById(R.id.categoryTitle);

        final View[] children = new View[] {menu, app};
        int scrollToViewIdx = 1;
        scrollView.initViews(children, scrollToViewIdx, new SizeCallbackForMenu(btnSlide));         
        
    	mPrefs = getSharedPreferences(PREFS_NAME, 0);                       
        listView = (ListView) app.findViewById(R.id.list);        
        
		if (common.isNetAvailable(this) == false) {
    		Toast toast = Toast.makeText(MainActivity.this, "Image can not be display due of no mobile or WIFI is connected", Toast.LENGTH_SHORT);
    		toast.setGravity(Gravity.CENTER, 0, 0);
    		toast.show();			
		}        
        
        try {
	        dbUtil.open();         
	        	Cursor cursor = dbUtil.getlastRecord();
	        	lastrecordfromlocal = cursor.getString(0);
			dbUtil.close();
        } catch (Exception e1) {
        	lastrecordfromlocal = "0";
        }
        
        if (mPrefs.getString(PREF_NEWSCATEGORY, "").equals("NULL")) {
        	categoryTitle.setText("Home");
        } else {
        	categoryTitle.setText(mPrefs.getString(PREF_NEWSCATEGORY, ""));
        }        
        
        if (lastrecordfromlocal.equals("0")) {
    		Intent intent = new Intent();
    		intent.setClass(MainActivity.this, Sync.class);
    		startActivity(intent);
        } else {
    		new LoadNewsLists().execute(mPrefs.getString(PREF_NEWSCATEGORY, ""));
        }        
        
	}   
	
    // Populate ListView and display
    public void populateArray(ArrayList<HashMap<String, Object>> getNews) {    	
        listView.setAdapter(new myListAdapter(getNews,this));
        listView.setChoiceMode(ListView.CHOICE_MODE_SINGLE);        
        
        mPrefs = getSharedPreferences(PREFS_NAME, 0);
                   
        listView.setOnItemClickListener(new OnItemClickListener() {
        	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {        		
        		Editor e = mPrefs.edit();
        		@SuppressWarnings("unchecked")
				HashMap<String, Object> o = (HashMap<String, Object>) listView.getItemAtPosition(position);       		        		        		
        		e.putString(PREF_NEWSID, o.get(NEWSID).toString());
        		e.commit();
    	        
        		Intent intent = new Intent();
        		intent.setClass(MainActivity.this, ReadNews.class);
        		startActivity(intent);        		
			}
		});    	          	
    }
    
    protected class LoadNewsLists extends AsyncTask<String, Void, ArrayList<HashMap<String, Object>>> {
    	private ProgressDialog progressDialog;
        protected void onPreExecute() {
        	progressDialog = ProgressDialog.show(MainActivity.this, "Message for you", common.getMessage()); 
        }

        protected ArrayList<HashMap<String, Object>> doInBackground(String... url) {        	          
        	getNews = new ArrayList<HashMap<String,Object>>();
    		
    		dbUtil.open();
    		HashMap<String, Object> hm;
    		Cursor cursor = dbUtil.fetchAllData(url[0]);
    		startManagingCursor(cursor);
    		if(cursor != null){			
    			while(cursor.moveToNext()){
    				hm = new HashMap<String, Object>();				
       		        hm.put(NEWSID, cursor.getString(0));
       		        hm.put(NEWSTITLE, cursor.getString(1));
       		        hm.put(NEWSIMAGE, cursor.getString(2));
       		        hm.put(NEWSCATEGORY, cursor.getString(3));
       		        getNews.add(hm);
       			}			   	
    		}
    		dbUtil.close();        	
            return getNews;
        }

        protected void onPostExecute(ArrayList<HashMap<String, Object>> getNews) {
        	populateArray(getNews);
        	progressDialog.dismiss();        	
        }
    }    
    
    
    private class myListAdapter extends BaseAdapter{
    	
    	private ArrayList<HashMap<String, Object>> parseNews; 
    	private LayoutInflater mInflater;
    	
		public myListAdapter(ArrayList<HashMap<String, Object>> pNews, Context context){
			parseNews = pNews;
			mInflater = LayoutInflater.from(context);
		}
    	
    	
    	@Override
		public int getCount() {
			// TODO Auto-generated method stub
			return parseNews.size();
		}

		@Override
		public Object getItem(int position) {
			// TODO Auto-generated method stub
			return parseNews.get(position);
		}

		@Override
		public long getItemId(int position) {
			// TODO Auto-generated method stub
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			Typeface font = Typeface.createFromAsset(getAssets(), "fonts/Zawgyi-One.ttf");
			final ViewHolder holder;
			 if (convertView == null) {
	             convertView = mInflater.inflate(R.layout.homepage, null);
	             holder = new ViewHolder();
	             holder.v = (TextView) convertView.findViewById(R.id.text1);
	             holder.v1 = (TextView) convertView.findViewById(R.id.text2);
	             holder.icon = (ImageView) convertView.findViewById(R.id.img);	             
	             convertView.setTag(holder);
	                
			 }else {
				 holder = (ViewHolder) convertView.getTag(); 
			 }
				holder.v.setText(Html.fromHtml("<b>" + (String) parseNews.get(position).get(NEWSTITLE) + "</b>"));
				holder.v.setPadding(2, 2, 2, 2);
				holder.v.setTypeface(font);
				holder.v1.setText("Category : Featured");
				holder.v1.setPadding(2, 2, 2, 2);
				holder.v1.setTypeface(font);
				if (common.isNetAvailable(MainActivity.this) == true) {
					ImageLoad downloader = new ImageLoad(holder.icon);
					downloader.execute((String)parseNews.get(position).get(NEWSIMAGE));
				}
	            holder.icon.setPadding(5, 5, 5, 5);
				return convertView;
		}
		
		class ViewHolder {
			TextView v;
			TextView v1;
	    	ImageView icon;	    	
        }    	
    }
    
    static class ClickListenerForScrolling implements OnClickListener {
        HorizontalScrollView scrollView;
        View menu;
        boolean menuOut = false;

        public ClickListenerForScrolling(HorizontalScrollView scrollView, View menu) {
            super();
            this.scrollView = scrollView;
            this.menu = menu;
        }

        @Override
        public void onClick(View v) {
            String msg = "Slide " + new Date();
            System.out.println(msg);

            int menuWidth = menu.getMeasuredWidth();

            // Ensure menu is visible
            menu.setVisibility(View.VISIBLE);

            if (!menuOut) {
                // Scroll to 0 to reveal menu
                int left = 0;
                scrollView.smoothScrollTo(left, 0);
            } else {
                // Scroll to menuWidth so menu isn't on screen.
                int left = menuWidth;
                scrollView.smoothScrollTo(left, 0);
            }
            menuOut = !menuOut;
        }
    }

    static class SizeCallbackForMenu implements SizeCallback {
        int btnWidth;
        View btnSlide;

        public SizeCallbackForMenu(View btnSlide) {
            super();
            this.btnSlide = btnSlide;
        }

        @Override
        public void onGlobalLayout() {
            btnWidth = btnSlide.getMeasuredWidth();
            System.out.println("btnWidth=" + btnWidth);
        }

        @Override
        public void getViewSize(int idx, int w, int h, int[] dims) {
            dims[0] = w;
            dims[1] = h;
            final int menuIdx = 0;
            if (idx == menuIdx) {
                dims[0] = w - btnWidth;
            }
        }
    }
    
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
     		AlertDialog.Builder alt_setting = new AlertDialog.Builder(MainActivity.this);
    		alt_setting.setMessage("Do you want to exit?")
    		.setCancelable(false)
    		.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				moveTaskToBack(true);
    			}
    		})
    		.setNegativeButton("No", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				dialog.cancel();
    			}
    		});
    		AlertDialog alert_setting = alt_setting.create();
    		alert_setting.setTitle("Planet Myanmar News");
    		alert_setting.show();
    		return true;
	    }
	    return false;
	}    
}