package com.ppshein.sevendaynews;

import java.util.ArrayList;
import java.util.Date;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Typeface;
import android.os.Bundle;
import android.os.Handler;
import android.text.Html;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.HorizontalScrollView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

import com.ppshein.sevendaynews.MyHorizontalScrollView.SizeCallback;

public class ReadNews extends Activity {
	private MyHorizontalScrollView scrollView;
	private View menu;
	private View app;
	private ImageView btnSlide;
    boolean menuOut = false;
    Handler handler = new Handler();
    int btnWidth;		
	
    public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_NEWSID = "PrefNewsID";
    private SharedPreferences mPrefs;
    DatabaseUtil dbUtil = new DatabaseUtil(this);
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
    	
    	// TODO Auto-generated method stub
    	super.onCreate(savedInstanceState);
    	requestWindowFeature(Window.FEATURE_NO_TITLE);
        LayoutInflater inflater = LayoutInflater.from(this);
        scrollView = (MyHorizontalScrollView) inflater.inflate(R.layout.horz_scroll_with_list_menu, null);
        setContentView(scrollView);

        menu = inflater.inflate(R.layout.horz_scroll_menu, null);
        app = inflater.inflate(R.layout.readnews, null);
        ViewGroup tabBar = (ViewGroup) app.findViewById(R.id.tabBar_ref);		

        ArrayList<common> image_details = common.GetSearchResults();        

        final ListView lv1 = (ListView) menu.findViewById(R.id.list);
        lv1.setAdapter(new ItemListBaseAdapter(this, image_details));
        
        lv1.setOnItemClickListener(new OnItemClickListener() {
        	@Override
        	public void onItemClick(AdapterView<?> a, View v, int position, long id) { 
        		Object o = lv1.getItemAtPosition(position);
        		common obj_itemDetails = (common)o;
        		Intent myIntent = common.reDirect(obj_itemDetails.getName(), ReadNews.this);
        		startActivity(myIntent);
        	}  
        });     	        
        
    	mPrefs = getSharedPreferences(PREFS_NAME, 0);       
        displayNews(mPrefs.getString(PREF_NEWSID, ""));
        
        btnSlide = (ImageView) tabBar.findViewById(R.id.BtnSlide);
        btnSlide.setOnClickListener(new ClickListenerForScrolling(scrollView, menu));        

        final View[] children = new View[] {menu, app};
        int scrollToViewIdx = 1;
        scrollView.initViews(children, scrollToViewIdx, new SizeCallbackForMenu(btnSlide));         
        
		if (common.isNetAvailable(this) == false) {
    		Toast toast = Toast.makeText(ReadNews.this, "Image can not be display due of no mobile or WIFI is connected", Toast.LENGTH_SHORT);
    		toast.setGravity(Gravity.CENTER, 0, 0);
    		toast.show();			
		}
    }     
    
    private void displayNews(String prefNewsId) {
    	Typeface font = Typeface.createFromAsset(getAssets(), "fonts/Zawgyi-One.ttf");
    	
		dbUtil.open();
		Cursor cursor = dbUtil.fetchNews(prefNewsId);
		startManagingCursor(cursor);
		TextView newstitle = (TextView) app.findViewById(R.id.newstitle);
		newstitle.setText(Html.fromHtml("<b>" + cursor.getString(0) + "</b>"));
		newstitle.setPadding(5, 2, 2, 3);
		newstitle.setTypeface(font);			
		ImageView newsimage = (ImageView) app.findViewById(R.id.newsimg);
		if (common.isNetAvailable(this) == true) {
			ImageLoad downloader = new ImageLoad(newsimage);
			downloader.execute(cursor.getString(1));
		}
        newsimage.setPadding(5, 5, 5, 5);
		TextView newstory = (TextView) app.findViewById(R.id.newsstory);
		newstory.setText(cursor.getString(2).replace("&quot;", "'"));		
		newstory.setTypeface(font);
		newstory.setPadding(5, 5, 5, 5);				
		dbUtil.close();
	}

    static class ClickListenerForScrolling implements OnClickListener {
        HorizontalScrollView scrollView;
        View menu;
        boolean menuOut = false;

        public ClickListenerForScrolling(HorizontalScrollView scrollView, View menu) {
            super();
            this.scrollView = scrollView;
            this.menu = menu;
        }

        @Override
        public void onClick(View v) {
            String msg = "Slide " + new Date();
            System.out.println(msg);

            int menuWidth = menu.getMeasuredWidth();

            // Ensure menu is visible
            menu.setVisibility(View.VISIBLE);

            if (!menuOut) {
                // Scroll to 0 to reveal menu
                int left = 0;
                scrollView.smoothScrollTo(left, 0);
            } else {
                // Scroll to menuWidth so menu isn't on screen.
                int left = menuWidth;
                scrollView.smoothScrollTo(left, 0);
            }
            menuOut = !menuOut;
        }
    }

    /**
     * Helper that remembers the width of the 'slide' button, so that the 'slide' button remains in view, even when the menu is
     * showing.
     */
    static class SizeCallbackForMenu implements SizeCallback {
        int btnWidth;
        View btnSlide;

        public SizeCallbackForMenu(View btnSlide) {
            super();
            this.btnSlide = btnSlide;
        }

        @Override
        public void onGlobalLayout() {
            btnWidth = btnSlide.getMeasuredWidth();
            System.out.println("btnWidth=" + btnWidth);
        }

        @Override
        public void getViewSize(int idx, int w, int h, int[] dims) {
            dims[0] = w;
            dims[1] = h;
            final int menuIdx = 0;
            if (idx == menuIdx) {
                dims[0] = w - btnWidth;
            }
        }
    }
    
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
			Intent intent = new Intent();
    		intent.setClass(ReadNews.this, MainActivity.class);
    		startActivity(intent);       		
	    }
	    return false;
	}
}
