package com.ppshein.sevendaynews;

import java.util.ArrayList;
import java.util.Date;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.database.Cursor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.HorizontalScrollView;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

import com.ppshein.sevendaynews.MyHorizontalScrollView.SizeCallback;

public class Sync extends Activity {
	
	private MyHorizontalScrollView scrollView;
	private View menu;
	private View app;
	private ImageView btnSlide;
    boolean menuOut = false;
    Handler handler = new Handler();
    int btnWidth;	
	
    private static final String JSONURL = "http://www.planet.com.mm/android/g.cfm";
    
	private ImageButton synbut;	
	private String lastrecordfromlocal;
	private ProgressDialog mProgressDialog;
	protected static final int DIALOG_KEY = 0;
	
	DatabaseUtil dbUtil = new DatabaseUtil(this);
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);                      
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        LayoutInflater inflater = LayoutInflater.from(this);
        scrollView = (MyHorizontalScrollView) inflater.inflate(R.layout.horz_scroll_with_list_menu, null);
        setContentView(scrollView);

        menu = inflater.inflate(R.layout.horz_scroll_menu, null);
        app = inflater.inflate(R.layout.sync, null);
        ViewGroup tabBar = (ViewGroup) app.findViewById(R.id.tabBar_ref);        
        
        ArrayList<common> image_details = common.GetSearchResults();
        
        final ListView lv1 = (ListView) menu.findViewById(R.id.list);
        lv1.setAdapter(new ItemListBaseAdapter(this, image_details));
        
        lv1.setOnItemClickListener(new OnItemClickListener() {
        	@Override
        	public void onItemClick(AdapterView<?> a, View v, int position, long id) { 
        		Object o = lv1.getItemAtPosition(position);
        		common obj_itemDetails = (common)o;
        		Intent myIntent = common.reDirect(obj_itemDetails.getName(), Sync.this);
        		startActivity(myIntent);
        	}  
        });
        
        synbut = (ImageButton) app.findViewById(R.id.syncdata);
        
		if (common.isNetAvailable(this) == false) {
    		Toast toast = Toast.makeText(Sync.this, "Please turn on mobile or wifi network to get latest news", Toast.LENGTH_SHORT);
    		toast.setGravity(Gravity.CENTER, 0, 0);
    		toast.show();
    		
    		synbut.setEnabled(false);
    		synbut.setAlpha(50);    		
		} else {
	        try {
		        dbUtil.open();         
		        	Cursor cursor = dbUtil.getlastRecord();
		        	lastrecordfromlocal = cursor.getString(0);
				dbUtil.close();
	        } catch (Exception e1) {
	        	lastrecordfromlocal = "0";
	        }			
			new IsComparedWord().execute(lastrecordfromlocal);
		}
        
		synbut.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View v) {
        		showDialog(DIALOG_KEY);
        		new InstallData().execute(JSONURL);    		
        	}
        });		
		
        btnSlide = (ImageView) tabBar.findViewById(R.id.BtnSlide);
        btnSlide.setOnClickListener(new ClickListenerForScrolling(scrollView, menu));

        final View[] children = new View[] {menu, app};
        int scrollToViewIdx = 1;
        scrollView.initViews(children, scrollToViewIdx, new SizeCallbackForMenu(btnSlide)); 		
		
	}
	
    static class ClickListenerForScrolling implements OnClickListener {
        HorizontalScrollView scrollView;
        View menu;
        boolean menuOut = false;

        public ClickListenerForScrolling(HorizontalScrollView scrollView, View menu) {
            super();
            this.scrollView = scrollView;
            this.menu = menu;
        }

        @Override
        public void onClick(View v) {
            String msg = "Slide " + new Date();
            System.out.println(msg);

            int menuWidth = menu.getMeasuredWidth();

            // Ensure menu is visible
            menu.setVisibility(View.VISIBLE);

            if (!menuOut) {
                // Scroll to 0 to reveal menu
                int left = 0;
                scrollView.smoothScrollTo(left, 0);
            } else {
                // Scroll to menuWidth so menu isn't on screen.
                int left = menuWidth;
                scrollView.smoothScrollTo(left, 0);
            }
            menuOut = !menuOut;
        }
    }

    /**
     * Helper that remembers the width of the 'slide' button, so that the 'slide' button remains in view, even when the menu is
     * showing.
     */
    static class SizeCallbackForMenu implements SizeCallback {
        int btnWidth;
        View btnSlide;

        public SizeCallbackForMenu(View btnSlide) {
            super();
            this.btnSlide = btnSlide;
        }

        @Override
        public void onGlobalLayout() {
            btnWidth = btnSlide.getMeasuredWidth();
            System.out.println("btnWidth=" + btnWidth);
        }

        @Override
        public void getViewSize(int idx, int w, int h, int[] dims) {
            dims[0] = w;
            dims[1] = h;
            final int menuIdx = 0;
            if (idx == menuIdx) {
                dims[0] = w - btnWidth;
            }
        }
    }   	
	
	protected Dialog onCreateDialog(int id) {
        switch (id) {
        case DIALOG_KEY:                                                               // 1
            mProgressDialog = new ProgressDialog(this);
            mProgressDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);         // 2
            mProgressDialog.setMessage("Installation data...");                       // 3
            mProgressDialog.setCancelable(false);                                      // 4
            return mProgressDialog;
        }
        return null;
    }	
	    
    private class IsComparedWord extends AsyncTask<String, Void, String> {
    	private ProgressDialog progressDialog;
                	
        // can use UI thread here
        protected void onPreExecute() {
        	progressDialog = ProgressDialog.show(Sync.this, "", "Loading...");
        }
        // automatically done on worker thread (separate from UI thread)
        protected String doInBackground(final String... args) {
        	String resultMessage = null;
        	JSONObject json = common.getJSONfromURL("http://www.planet.com.mm/android/IsCompared.cfm", args[0]);
        	JSONArray newsjson;
			try {				
				newsjson = json.getJSONArray("planetnews");
				for (int i = 0; i < newsjson.length(); i++) {                
					JSONObject e = newsjson.getJSONObject(i);
					resultMessage = e.getString("newwords");                    
	            }        	
				
			} catch (JSONException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
                    	      	                        
        	return resultMessage.toString();
        }
        // can use UI thread here
        protected void onPostExecute(final String result) {
        	progressDialog.dismiss();
        	if (result.equals("0")) {
        		Toast toast = Toast.makeText(Sync.this, "There is no updated news yet", Toast.LENGTH_SHORT);
        		toast.setGravity(Gravity.CENTER, 0, 0);
        		toast.show();
        		synbut.setAlpha(50);
        		synbut.setEnabled(false);
        	} else {
        		Toast toast = Toast.makeText(Sync.this, "We found updated news. Click below button to update database.", Toast.LENGTH_SHORT);
        		toast.setGravity(Gravity.CENTER, 0, 0);
        		toast.show();
        		synbut.setAlpha(255);
        		synbut.setEnabled(true);        		
        	}
        }
     }
    
    protected class InstallData extends AsyncTask<String, Integer, String> {        
        @Override
        protected void onPreExecute() {
        	mProgressDialog.show();
        }
        
        @Override
        protected String doInBackground(String... urls) {
        	try {
	        	JSONObject json = common.getJSONfromURL(urls[0], lastrecordfromlocal);
	        	JSONArray  newsjson = json.getJSONArray("planetnews");
	        	dbUtil.open();
	            for (int i = 0; i < newsjson.length(); i++) {                
	            	JSONObject e = newsjson.getJSONObject(i);
	    			dbUtil.insertRecord(e.getString("newsid"), e.getString("newstitle"), e.getString("newsimage"), e.getString("newslargeimage"), e.getString("newsstory"), e.getString("newscategory"));
	    			publishProgress((int) (((i+1) / (float) newsjson.length()) * 100));
	            }
            } catch (JSONException e) {
                e.printStackTrace();                
            }            
            dbUtil.close();
            return "DONE";
        }
        
        @Override
        protected void onProgressUpdate(Integer... values) {
            mProgressDialog.setProgress(values[0]);         
        }
        
        @Override
        protected void onPostExecute(String result) {            
    		Intent intent = new Intent();
    		intent.setClass(Sync.this, MainActivity.class);
    		startActivity(intent);  
        }        
    }
    
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
			Intent intent = new Intent();
    		intent.setClass(Sync.this, MainActivity.class);
    		startActivity(intent);       		
	    }
	    return false;
	}    
}
