package com.ppshein.sevendaysnews;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.database.Cursor;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.KeyEvent;
import android.view.Window;
import android.widget.TextView;

public class Index extends Activity {
	
	public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_LASTSID = "PrefLastID";
    
	private SharedPreferences mPrefs;
	private String lastrecordfromlocal;
	private TextView lastUpdated;
	
	DatabaseUtil dbUtil = new DatabaseUtil(this);       
    
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);                      
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.index);
        lastUpdated = (TextView) findViewById(R.id.txtLastUpdated);
        
        mPrefs = getSharedPreferences(PREFS_NAME, 0);
        myTimer.start();
        
        try {
	        dbUtil.open();         
	        	Cursor cursor = dbUtil.getlastRecord();
	        	lastrecordfromlocal = cursor.getString(0);
	        	lastUpdated.setText("Last updated on : " + cursor.getString(1));
	        	lastUpdated.setPadding(5, 2, 2, 3);
			dbUtil.close();
        } catch (Exception e1) {
        	lastrecordfromlocal = "0";
        }
        
		Editor e = mPrefs.edit();    		      		        		        	
			e.putString(PREF_LASTSID, lastrecordfromlocal);
		e.commit();         
	}
    
	
	private CountDownTimer myTimer = new CountDownTimer(5000, 1000) {
	    public void onFinish() {
    		Intent intent = new Intent();
    		intent.setClass(Index.this, MainActivity.class);
    		startActivity(intent);
	    }
		@Override
		public void onTick(long arg0) {
		}
	};	
	
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
     		AlertDialog.Builder alt_setting = new AlertDialog.Builder(Index.this);
    		alt_setting.setMessage("Do you want to exit?")
    		.setCancelable(false)
    		.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				moveTaskToBack(true);
    			}
    		})
    		.setNegativeButton("No", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				dialog.cancel();
    			}
    		});
    		AlertDialog alert_setting = alt_setting.create();
    		alert_setting.show();
    		return true;
	    }
	    return false;
	}    
}