package com.ppshein.sevendaysnews;

import java.util.ArrayList;
import java.util.HashMap;

import com.deaux.fan.FanView;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.database.Cursor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class MainActivity extends Activity {
	
	private ListView sideMenuList;
	private FanView fan;	
	
	private TextView categoryTitle, updatedCount;
	private ListView listView;
	private ImageView btnSlide, btnShare;
	public ProgressBar tabSync;
	
    public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_NEWSID = "PrefNewsID";
    public static final String PREF_NEWSCATEGORY = "PrefNewsCategory";
    public static final String PREF_LASTSID = "PrefLastID";
    
    private SharedPreferences mPrefs;    		
    
    private static final String NEWSID = "newsid";
    private static final String NEWSTITLE = "newstitle";
	private static final String NEWSIMAGE = "newsimage";
	private static final String NEWSCATEGORY = "newscategory";
	private static final String NEWSUPDATED = "newsdatemodified";
	private ImageLoader imgLoader;
	
	private ArrayList <HashMap<String, Object>> getNews;
	DatabaseUtil dbUtil = new DatabaseUtil(this);

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.common);
        fan = (FanView) findViewById(R.id.fan_view);
        fan.setViews(R.layout.main, R.layout.sidemenu);
        categoryTitle = (TextView) findViewById(R.id.categoryTitle);        
        
        imgLoader = new ImageLoader(this);
        
    	mPrefs = getSharedPreferences(PREFS_NAME, 0);                       
        listView = (ListView) findViewById(R.id.list);        
        
        sidemenu[] sidemenu_data = common.sideMenuData();        
        sidemenuadapter adapter = new sidemenuadapter(this, R.layout.listview_item_row, sidemenu_data);
        
        sideMenuList = (ListView)findViewById(R.id.listView1);                 
        sideMenuList.setAdapter(adapter);
        sideMenuList.setOnItemClickListener(new OnItemClickListener() {
        	@Override
        	public void onItemClick(AdapterView<?> a, View v, int position, long id) {        		
        		sidemenu item = (sidemenu) a.getItemAtPosition(position);        		
        		Intent myIntent = common.reDirect(item.title, MainActivity.this);
        		startActivity(myIntent);
        	}  
        });
        
        ViewGroup tabBar = (ViewGroup) findViewById(R.id.tabBar_ref);
        btnSlide = (ImageView) tabBar.findViewById(R.id.BtnSlide);
        tabSync = (ProgressBar) tabBar.findViewById(R.id.tabSync);
        updatedCount = (TextView) tabBar.findViewById(R.id.updatedCount);
        
        btnSlide.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View v) {
        		fan.showMenu();
        	}
        });
        
		if (common.isNetAvailable(this) == true) {
			SyncTask InstallData = new SyncTask(this, mPrefs.getString(PREF_LASTSID, ""), tabSync, updatedCount);
			InstallData.execute(mPrefs.getString(PREF_LASTSID, ""));
		}        
        
        if (mPrefs.getString(PREF_NEWSCATEGORY, "").equals("NULL")) {
        	categoryTitle.setText("Home");
        } else {
        	categoryTitle.setText(mPrefs.getString(PREF_NEWSCATEGORY, ""));
        }        
        
        if (mPrefs.getString(PREF_LASTSID, "").equals("0")) {
    		Toast toast = Toast.makeText(MainActivity.this, "We have not found any news. Please sync first.", Toast.LENGTH_SHORT);
    		toast.setGravity(Gravity.CENTER, 0, 0);
    		toast.show();
        } else {
    		new LoadNewsLists().execute(mPrefs.getString(PREF_NEWSCATEGORY, ""));
        }
        
        btnShare = (ImageView) tabBar.findViewById(R.id.btnShare);
        btnShare.setImageResource(R.drawable.sync); 

        btnShare.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View v) {
        		if (common.isNetAvailable(MainActivity.this) == true) {
        			SyncTask InstallData1 = new SyncTask(MainActivity.this, mPrefs.getString(PREF_LASTSID, ""), tabSync, updatedCount);
        			InstallData1.execute(mPrefs.getString(PREF_LASTSID, ""));        			
        		} else {
            		Toast toast = Toast.makeText(MainActivity.this, "Please turn on mobile or wifi network to get latest news", Toast.LENGTH_SHORT);
            		toast.setGravity(Gravity.CENTER, 0, 0);
            		toast.show();
        		}
        	}
        });
                
        updatedCount.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View v) {
                try {
                	updatedCount.setVisibility(View.INVISIBLE);
        	        dbUtil.open();         
        	        	Cursor cursor = dbUtil.getlastRecord();
        	        	Editor e = mPrefs.edit();
        	        		e.putString(PREF_LASTSID,  cursor.getString(0));
                		e.commit();        	        	
        			dbUtil.close();
            		Intent intent = new Intent();
            		intent.setClass(MainActivity.this, MainActivity.class);
            		startActivity(intent);        			
                } catch (Exception e1) {
                	
                }        		
        	}        	
        }); 			
        
	}   
	
    // Populate ListView and display
    public void populateArray(ArrayList<HashMap<String, Object>> getNews) {    	
        listView.setAdapter(new myListAdapter(getNews, this, NEWSTITLE, NEWSCATEGORY, NEWSUPDATED, NEWSIMAGE, imgLoader));
        listView.setChoiceMode(ListView.CHOICE_MODE_SINGLE);        
        
        mPrefs = getSharedPreferences(PREFS_NAME, 0);                   
        listView.setOnItemClickListener(new OnItemClickListener() {
        	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {        		
        		Editor e = mPrefs.edit();
        		@SuppressWarnings("unchecked")
				HashMap<String, Object> o = (HashMap<String, Object>) listView.getItemAtPosition(position);       		        		        		
        		e.putString(PREF_NEWSID, o.get(NEWSID).toString());
        		e.commit();
    	        
        		Intent intent = new Intent();
        		intent.setClass(MainActivity.this, ReadNews.class);
        		startActivity(intent);        		        		
			}
		});    	          	
    }
    
    protected class LoadNewsLists extends AsyncTask<String, Void, ArrayList<HashMap<String, Object>>> {
    	private ProgressDialog progressDialog;
    	private Integer i = 0, startfrom = 0;
        protected void onPreExecute() {
        	progressDialog = ProgressDialog.show(MainActivity.this, "", "Loading...");
        }

        protected ArrayList<HashMap<String, Object>> doInBackground(String... arg) {        	          
        	getNews = new ArrayList<HashMap<String,Object>>();
    		dbUtil.open();
    		HashMap<String, Object> hm;
    		Cursor cursor = dbUtil.fetchAllData(arg[0]);
    		startManagingCursor(cursor);
    		if(cursor != null){			
    			while(cursor.moveToNext()){
    				hm = new HashMap<String, Object>();
    				i = i + 1;
    				if (i == 30) {
    					startfrom = Integer.parseInt(cursor.getString(0));
    				}    				
       		        hm.put(NEWSID, cursor.getString(0));
       		        hm.put(NEWSTITLE, cursor.getString(1));
       		        hm.put(NEWSIMAGE, cursor.getString(2));
       		        hm.put(NEWSCATEGORY, cursor.getString(3));
       		        hm.put(NEWSUPDATED, cursor.getString(4));
       		        getNews.add(hm);
       			}			   	
    		}
    		
    		if (startfrom != 0) {    			
    			Boolean del = dbUtil.DeleteOldData(startfrom);
    			Log.v ("Deleted", "Deleted " + del);
    		}    		
    		cursor.close();
    		dbUtil.close();        	
            return getNews;
        }

        protected void onPostExecute(ArrayList<HashMap<String, Object>> getNews) {
        	populateArray(getNews);
        	progressDialog.dismiss();        	
        }
    }    
    
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
     		AlertDialog.Builder alt_setting = new AlertDialog.Builder(MainActivity.this);
    		alt_setting.setMessage("Do you want to exit?")
    		.setCancelable(false)
    		.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				moveTaskToBack(true);
    			}
    		})
    		.setNegativeButton("No", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				dialog.cancel();
    			}
    		});
    		AlertDialog alert_setting = alt_setting.create();
    		alert_setting.show();
    		return true;
	    }
	    return false;
	}
	
	public boolean onKeyUp(int keyCode, KeyEvent event) {
	    if (keyCode == KeyEvent.KEYCODE_MENU) {
	    	fan.showMenu();  	    	
	    }
	    return true;
	}	
}