package com.ppshein.sevendaysnews;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.content.Context;
import android.os.AsyncTask;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;

public class SyncTask extends AsyncTask<String, Void, String> {
	private Context context;
	private ProgressBar progress;
	private TextView updatedCount;

    public SyncTask(Context context, String agrs, ProgressBar progress, TextView updatedCount) {
        this.context = context;
        this.progress = progress;
        this.updatedCount = updatedCount;
    }    	
	
    protected void onPreExecute() {
    	progress.setVisibility(View.VISIBLE);    	
    }
    
    protected String doInBackground(String... args) {
    	int i = 0;
    	DatabaseUtil dbUtil = new DatabaseUtil(context);
    	try {
        	JSONObject json = common.getJSONfromURL("", args[0]);
        	JSONArray  newsjson = json.getJSONArray("7daynews");
        	dbUtil.open();
            for (i = 0; i < newsjson.length(); i++) {                
            	JSONObject e = newsjson.getJSONObject(i);
            	dbUtil.insertRecord(e.getString("newsid"), e.getString("newstitle"), e.getString("newsimage"), e.getString("newslargeimage"), e.getString("newsstory"), e.getString("newscategory"), e.getString("newscreate"));	    			
            }
            dbUtil.close();
        } catch (JSONException e) {
            e.printStackTrace();                
        }                        
        return i + "";
    }
    
    protected void onPostExecute(final String result) {
    	progress.setVisibility(View.INVISIBLE);
    	if (result.equals("0")) {
    		updatedCount.setVisibility(View.INVISIBLE);
    	} else {
    		updatedCount.setVisibility(View.VISIBLE);
    		updatedCount.setText(result);
    	}    	
    }
}
