package com.ppshein.sevendaysnews;

import java.util.ArrayList;
import java.util.HashMap;

import android.content.Context;
import android.graphics.Typeface;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class myListAdapter extends BaseAdapter{
	
	private ArrayList<HashMap<String, Object>> parseNews; 
	private LayoutInflater mInflater;
	private String ptitle, pcategory, pmodified, pimage;
	private Context ctx;
	private ImageLoader imgLoader;
	
	public myListAdapter(ArrayList<HashMap<String, Object>> pNews, Context context, String stitle, String scategory, String smodified, String simage, ImageLoader imgLoad){
		parseNews = pNews;
		mInflater = LayoutInflater.from(context);
		
		ptitle = stitle;
		pcategory = scategory;
		pmodified = smodified;
		pimage = simage;
		ctx = context;
		imgLoader = imgLoad;
	}
	
	
	@Override
	public int getCount() {
		// TODO Auto-generated method stub
		return parseNews.size();
	}

	@Override
	public Object getItem(int position) {
		// TODO Auto-generated method stub
		return parseNews.get(position);
	}

	@Override
	public long getItemId(int position) {
		// TODO Auto-generated method stub
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		Typeface font = Typeface.createFromAsset(ctx.getAssets(), "fonts/Zawgyi-One.ttf");
		final ViewHolder holder;
		 if (convertView == null) {
             convertView = mInflater.inflate(R.layout.homepage, null);
             holder = new ViewHolder();
             holder.v = (TextView) convertView.findViewById(R.id.text1);
             holder.v1 = (TextView) convertView.findViewById(R.id.text2);
             holder.icon = (ImageView) convertView.findViewById(R.id.img);	             
             convertView.setTag(holder);
                
		 }else {
			 holder = (ViewHolder) convertView.getTag(); 
		 }
			holder.v.setText(Html.fromHtml("<b>" + (String) parseNews.get(position).get(ptitle) + "</b>"));
			holder.v.setPadding(2, 2, 2, 2);
			holder.v.setTypeface(font);
			holder.v1.setText("Category : " + (String) parseNews.get(position).get(pcategory) + " on " + (String) parseNews.get(position).get(pmodified));
			holder.v1.setPadding(2, 2, 2, 2);
			holder.v1.setTypeface(font);
			imgLoader.DisplayImage((String)parseNews.get(position).get(pimage), holder.icon);
            holder.icon.setPadding(5, 5, 5, 5);
			return convertView;
	}
	
	class ViewHolder {
		TextView v;
		TextView v1;
    	ImageView icon;	    	
    }    	
} 
